

-- LilSparky's Workshop -- Addon for WOW Trade Skill frames
-- Lilsparky of Lothar
-- v0.90
-- feb.1.2009


do
	local LSW_VERSION = "LSW v0.91";
	local LSW_VERSION_LONG = "LilSparky's Workshop v0.91"

	local ATSW_ShowWindow_ORIGINAL = nil;

	local SkilletFrame_Show_ORIGINAL = nil;
	local SkilletFrame_Update_ORIGINAL = nil;
	local SkilletBeforeRecipeButtonShow_ORIGNAL = nil;
	local SkilletBeforeRecipeButtonHide_ORIGINAL = nil;


	local TradeSkillFrame_Show_ORIGINAL = nil;
	local TradeSkillFrame_Update_ORIGINAL = nil;


	---

	local LSW_initialized = false;
	local LSW_pricingInitialized = false;


	local LSW_Mode = "TradeSkill";

	local LSW_AuctioneerHook = "";

	local LSW_TRADESKILL_INDEX_MAX = 8


	local LSW_MINIMUM_REAGENT_AUCTIONS = 10
	local LSW_MINIMUM_ITEM_AUCTIONS = 1

	local LSW_ENCHANT_ID="?"		-- enchants have no item fate

	local LSW_itemFateColor={
		["d"]="ff008000",
		["a"]="ff909050",
		["v"]="ff206080",
		["?"]="ff800000",
	}

--	local LSW_itemFateColor[LSW_ENCHANT_ID]="ffffffff";
	local LSW_globalSync = 1;
	local LSW_skillPriceCache={};
	local LSW_itemMade={}
	local LSW_itemSource={}

	local LSW_globalFate = 0;
	local LSW_globalFateMax = 3;
	local LSW_valueAsPercent = false; 	-- display % for values


	-- these could certainly be made language specific if needed
	local LSW_itemFateList={"a", "v", "d"};

	local LSW_fateString={["a"]="Auction", ["v"]="Vendor", ["d"]="Disenchant"};


	local LSW_skillWidthNarrow = 223;
	local LSW_skillWidthWide = 243;

	local LSW_skillWidth = LSW_skillWidthWide;

	local LSW_itemPriceVendor = nil;
	local LSW_itemPriceAuction = nil;

	local LSW_priceSanity = true;

	local LSW_Tooltip = nil;

	local LSW_linkCache = {};

	local LSW_periodicTableLib = nil;

	local LSW_BOP_STRING = "|cffff0000-BOP-|r"
	local LSW_NODE_STRING = "|cffff0000-NO DE-|r"


	local aucAlgorithm = "Market"

	local aucEngines = {}
	local aucEngineMenu = {}

	local LSWMenuFrame = CreateFrame("Frame","LSWMenuFrame",UIParent,"UIDropDownListTemplate")


	local ValueMenu =
	{
		{
			text = "Show Value as Percent",
			func = function ()
				LSW_valueAsPercent = not LSW_valueAsPercent
				LSW_UpdateWindow()
			end
		}
	}



	local function LSW_ChatMessage(msg)
		DEFAULT_CHAT_FRAME:AddMessage("|cff80d060"..(msg or "nil"));
	end

	local function LSW_ErrorMessage(msg)
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..(msg or "nil"));
	end





	local function LSW_GetTradeSkillInfo(index)
		local skillName, skillType, numAvailable, isExpanded;

		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillInfo) then
			skillName, skillType, numAvailable, isExpanded = Skillet:GetTradeSkillInfo(index);
		else
			skillName, skillType, numAvailable, isExpanded = GetTradeSkillInfo(index);
		end

		return skillName, skillType, numAvailable, isExpanded;
	end


	local function LSW_GetTradeSkillNumMade(index)
		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillNumMade) then
			return Skillet:GetTradeSkillNumMade(index);
		else
			return GetTradeSkillNumMade(index);
		end
	end


	local function LSW_GetTradeSkillNumReagents(index)
		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillNumReagents) then
			return Skillet:GetTradeSkillNumReagents(index);
		else
			return GetTradeSkillNumReagents(index);
		end
	end


	local function LSW_GetTradeSkillReagentInfo(index, reagentIndex)
		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillReagentInfo) then
			return Skillet:GetTradeSkillReagentInfo(index, reagentIndex);
		else
			return GetTradeSkillReagentInfo(index, reagentIndex);
		end
	end

	local function LSW_GetTradeSkillReagentItemLink(index, reagentIndex)
		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillReagentItemLink) then
			return Skillet:GetTradeSkillReagentItemLink(index, reagentIndex);
		else
			return GetTradeSkillReagentItemLink(index, reagentIndex);
		end
	end

	local function LSW_GetTradeSkillItemLink(index)
		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillItemLink) then
			return Skillet:GetTradeSkillItemLink(index);
		else
			return GetTradeSkillItemLink(index);
		end
	end


	local function LSW_GetTradeSkillRecipeLink(index)
		if (LSW_Mode == "Skillet" and Skillet.GetTradeSkillRecipeLink) then
			return Skillet:GetTradeSkillRecipeLink(index);
		else
			return GetTradeSkillRecipeLink(index);
		end
	end





	local function LSW_findID(link)
		if not link then return end

		local found, _, itemString = string.find(link, "^|c%x+|H(.+)|h%[.+%]")
		local id

		if found then
			_, id = string.split(":",itemString)
		end

		return tonumber(id)
	end


	local function LSW_queryServerInfo(link)
		local id = LSW_findID(link);

		if (not id) then
			id = LSW_findID(link)

			if ( id) then id = "e"..id end
		end

		if (id and not LSW_linkCache[id]) then
			LSW_linkCache[id] = true;


			if (not GetItemInfo(link)) then
				LSW_ErrorMessage("no local cache info for "..link);
	--			GameTooltip:SetHyperlink(link);
			end
		end
	end


	function LSW_formatMoney(moneyString,hilight)
		local money = tonumber(moneyString);
		if (money < 0) then return "   --"; end

		local GSC_GOLD = "ff807000"
		local GSC_SILVER = "ff808080"
		local GSC_COPPER = "ff643016"

		if (hilight) then
			GSC_GOLD="ffffd100"
			GSC_SILVER="ffe6e6e6"
			GSC_COPPER="ffc8602c"
		end

		local g, s, c;
		local digits = 0

		g = math.floor(money/10000);
		s = math.fmod(math.floor(money/100),100);
		c = math.fmod(money,100);

		if (money > 0) then
			digits = math.floor(math.log10(money)+1)
		end

		if ( digits < 3 ) then
			gsc = string.format("   |c%s%2d|r",  GSC_COPPER, c);
		elseif ( digits < 5 ) then
			gsc = string.format("|c%s%2d|r |c%s%02d|r", GSC_SILVER, s, GSC_COPPER, c)
		elseif ( digits < 7 ) then
			gsc = string.format("|c%s%2d|r |c%s%02d|r", GSC_GOLD, g, GSC_SILVER, s)
		else
			gsc = string.format("|c%s%5d|r", GSC_GOLD, g);
		end

		return gsc
	end


	local function LSW_GetSkillByID(id)
		local skillName;
		local skillLink;
		local skillType;
		local skillID;
		local recipeLink;
		local recipeID;

		if (LSW_Mode == "ATSW") then
			local listpos=ATSW_GetSkillListingPos(id);

			if(atsw_skilllisting[listpos]) then
				skillName = atsw_skilllisting[listpos].name;
				skillLink = atsw_skilllisting[listpos].link;
				skillType = atsw_skilllisting[listpos].type;
				skillID =   atsw_skilllisting[listpos].id;
				recipeLink = atsw_skilllisting[listpos].recipelink;
			end
		else
			skillID=id;
			skillName, skillType = LSW_GetTradeSkillInfo(skillID);
			skillLink = LSW_GetTradeSkillItemLink(skillID);
			recipeLink = LSW_GetTradeSkillRecipeLink(skillID);
		end

		recipeID = LSW_findID(recipeLink);

		return skillName, LSW_findID(skillLink), skillType, skillID, recipeID;
	end




	local function LSW_bopCheck(item)
		local tooltip = getglobal("LSWParsingTooltip");
		local bop = false;

		if tooltip == nil then
			tooltip = CreateFrame("GameTooltip", "LSWParsingTooltip", getglobal("ANCHOR_NONE"), "GameTooltipTemplate");
			tooltip:SetOwner(WorldFrame, "ANCHOR_NONE");
		end

		tooltip:SetHyperlink("item:"..item);

		local tiplines = tooltip:NumLines();

		for i=1, tiplines, 1 do
			local lineText = string.lower(getglobal("LSWParsingTooltipTextLeft"..i):GetText() or " ");

			if (string.find(lineText, "binds when picked up")) then
				bop = true;
				break;
			end
		end

		return bop;
	end


	local function LSW_findItemFullID(link)
		local itemID, suffixID = link:match("item:(%-?%d+):(%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:)%-?%d+")
		local fullID = ("%s:%s0"):format(itemID, suffixID)

		return fullID;
	end

	local function LSW_findItemShortCode(link)
		return tonumber(link:match("item:(%-?%d+)"))
	end





	local function LSW_itemPriceVendor(link, minSeen)
		return 0, 0, true;
	end


	local function LSW_itemPriceVendorGetSellValue(link)
		local gsv = GetSellValue(link);

		if (gsv) then
			return gsv/4, gsv, false;
		else
			return 0, 0, true;
		end
	end



	local function LSW_itemPriceVendorInformant(link)
		local sell = 0
		local buy = 0
		local itemInfo = nil;
		local quant;

		local itemID = LSW_findID(link)

		if (itemID and itemID > 0) and (Informant) then
			itemInfo = Informant.GetItem(itemID)
		end

		if (not itemInfo) then return 0,0, true end

		buy = tonumber(itemInfo.buy) or 0
		sell = tonumber(itemInfo.sell) or 0
		quant = tonumber(itemInfo.quantity) or 0

		if (quant > 1) then buy = buy / quant; end

		return buy, sell, false
	end


	local function LSW_itemPriceVendorKCItems(link)
		local id = LSW_findItemShortCode(link);

		local sell, buy = SellValues:GetValues(id);

	--LSW_ChatMessage("vendor price: link "..link.." id: "..id.." buy: "..(buy or "nil").." sell: "..(sell or "nil"));

		if (buy) then
			return buy, sell, false;
		else
			return 0,0,true;
		end
	end




	function LSW_itemPrice(link, minSeen)
		return 0, true;
	end


	local function LSW_itemPriceKCItems(link, minSeen) -- KC_Items version
		local id = LSW_findItemFullID(link);
		local faction = UnitFactionGroup("player");
		local buyout = -1;

	--LSW_ChatMessage("ah price: faction:"..faction.." link "..link.." id: "..id);

		local mktV, hmktV, avgStkSz, stkSzCfrm, mAvg, hmAvg, mStdDev, mMax, yAvg, hyAvg, yStdDev, yMin, bAvg, hbAvg, bStdDev, bMax = AuctionSpy:GetItemInfo(faction, id)
		if (mktV) then
			buyout = (yAvg - yStdDev); -- dunno how to find the number of items in the database

			return buyout, false;
	--LSW_ChatMessage("ah price: link "..link.." id: "..id.." buy: "..(buyout or "nil"));
		end

		return buyout, true;
	--	end

	--	if (not minSeen) then minSeen = 1; end

	--	if (seen < minSeen) then
	--		return 0, true;
	--	end

	--	return priceBuyout, false;
	end


	local function LSW_itemPriceAuctionLite(link) -- auctionlite version
		if (not AuctionLite or not link) then return 0, true; end

		sellPrice = AuctionLite:GetAuctionValue(link)

--price = AuctionLite:GetVendorValue(link or id[, suffix])
		if sellPrice then
			return sellPrice, false
		else
			return 0, true
		end
	end

	local function LSW_itemPriceAuctionMaster(link) -- auctionMaster version
		if (not AuctionMaster or not link) then return 0, true; end

		_, sellPrice = AuctionMaster.Statistic:GetAuctionInfo(link, false)

		if sellPrice then
			return sellPrice, false
		else
			return 0, true
		end
	end


	local function LSW_itemPriceAucAdvanced(link, minSeen) -- aucadvanced version (work in progress)
		local numSeen;

		if (not link) then return 0, true; end

		if (not minSeen) then minSeen = 1; end

		local sellPrice=0;

		if aucAlgorithm == "Market" then
			sellPrice, numSeen = AucAdvanced.API.GetMarketValue(link);
		elseif aucAlgorithm == "Appraiser" then
			sellPrice, numSeen = AucAdvanced.Modules.Util.Appraiser.GetPrice(link);
		else
			sellPrice, numSeen = AucAdvanced.API.GetAlgorithmValue(aucAlgorithm, link);
		end

		if (not sellPrice or numSeen < minSeen) then
			return 0, true;
		end

		return sellPrice, false;
	end


	local function LSW_InitializePricing()
		AuctionMaster = vendor -- not sure why...

		if (GetSellValue) then
			LSW_ChatMessage("LilSparky's Workshop has found GetSellValue");
			LSW_itemPriceVendor = LSW_itemPriceVendorGetSellValue;
		elseif (Informant) then
			LSW_ChatMessage("LilSparky's Workshop has found Informant");
			LSW_itemPriceVendor = LSW_itemPriceVendorInformant;
		else
			LSW_ErrorMessage("ERROR: LilSparky's Workshop cannot find a suitable vendor pricing system.");
			return false;
		end


		if (AucAdvanced and AucAdvanced.Version) then
			LSW_AuctioneerHook = "aucadv"

			LSW_ChatMessage("LilSparky's Workshop has found AucAdvanced (v"..AucAdvanced.Version..")");
			LSW_itemPrice = LSW_itemPriceAucAdvanced;



			aucEngines = AucAdvanced.GetAllModules(nil, "Stat")

			aucEngineMenu = {
				{
					text = "Select Pricing Module",
					isTitle = true,
				},
				{
					text = "Market",
					func = function()
						aucAlgorithm = "Market"
						LSW_globalSync = LSW_globalSync+1
						LSW_UpdateWindow()
					end,
				},
				{
					text = "Appraiser",
					func = function()
						aucAlgorithm = "Appraiser"
						LSW_globalSync = LSW_globalSync+1
						LSW_UpdateWindow()
					end,
				},
			}


			for pos, engineLib in ipairs(aucEngines) do
				local name = engineLib.GetName()

				local button = {
					text = name,
					func = function()
						aucAlgorithm = name
						LSW_globalSync = LSW_globalSync+1
						LSW_UpdateWindow()
					end,
				}

				table.insert(aucEngineMenu, button)
			end


			table.insert(ValueMenu,{ text = "Select Pricing Module", menuList = aucEngineMenu, hasArrow = true })
		elseif (AuctionLite) then
			LSW_ChatMessage("LilSparky's Workshop has found AuctionLite");

--			LSW_itemPrice = LSW_itemPriceKCItems;

			LSW_itemPrice = LSW_itemPriceAuctionLite;
		elseif AuctionMaster then
			LSW_ChatMessage("LilSparky's Workshop has found AuctionMaster");

			LSW_itemPrice = LSW_itemPriceAuctionMaster
		elseif (AuctionSpy and KC_Items) then
			LSW_ChatMessage("LilSparky's Workshop has found KC_Items/AuctionSpy.");

			LSW_itemPrice = LSW_itemPriceKCItems;

			if (KC_Items:HasModule("SellValues")) then
				SellValues = KC_Items:GetModule("SellValues");

				LSW_ChatMessage("LilSparky's Workshop has found KC_Items/SellValues.");
				LSW_itemPriceVendor = LSW_itemPriceVendorKCItems;
			end
		else
			LSW_ErrorMessage("ERROR: LilSparkys Workshop cannot find a suitable auction module.");
			return false;
		end


		if (LSW_itemPriceVendor == nil) then

		end


		if (Enchantrix) then
			LSW_globalFateMax = 3
		else
			LSW_ChatMessage("WARNING: LilSparky's Workshop needs Enchantrix to calculate disenchant values.");
			LSW_globalFateMax = 2
		end

		return true;
	end


	local function LSW_itemValuation(recipeID, itemID, skillID)
		if (not LSW_pricingInitialized) then
			LSW_pricingInitialized = true;
			LSW_InitializePricing();
			local minorVersion;

			if (LibStub) then
				LSW_periodicTableLib, minorVersion = LibStub:GetLibrary("LibPeriodicTable-3.1", true)

				if (LSW_periodicTableLib) then
					LSW_ChatMessage("LilSparky's Workshop using LibPeriodicTable-3.1 ("..minorVersion..") for vendor availablity data");
				end
			end
		end

		if (LSW_itemPrice == nil or LSW_itemPriceVendor == nil) then
			return -1, -1, "?";
		end

		if (LSW_skillPriceCache == nil) then return -1, -1, "?" end

		if (LSW_skillPriceCache[recipeID] == nil) then
			LSW_skillPriceCache[recipeID]={}
			LSW_skillPriceCache[recipeID].sync = 0
			LSW_skillPriceCache[recipeID].valueAmount = {};
		else
			if (LSW_skillPriceCache[recipeID].sync == LSW_globalSync) then
				if (LSW_globalFate==0) then
					return LSW_skillPriceCache[recipeID].costAmount, LSW_skillPriceCache[recipeID].valueAmount[LSW_globalFate], LSW_skillPriceCache[recipeID].itemFate;
				else
					return LSW_skillPriceCache[recipeID].costAmount, LSW_skillPriceCache[recipeID].valueAmount[LSW_globalFate], LSW_itemFateList[LSW_globalFate];
				end
			end
		end

		local cache = LSW_skillPriceCache[recipeID];
		cache.sync = LSW_globalSync;
		cache.valueAmount[1] = -1;
		cache.valueAmount[2] = -1;
		cache.valueAmount[3] = -1;

		local sell = 0;
		local buy = 0;
		local stacks = 1;
		local itemFate = "?"

		local dummy;

		local numReagents;

		local dePricer=nil;

		numReagents = LSW_GetTradeSkillNumReagents(skillID);

		if (Enchantrix) then
			dePricer = Enchantrix.Storage.GetItemDisenchantTotals;
		end

	-- LSW_ChatMessage(skillLink);
		LSW_queryServerInfo(skillLink);

		for i=1, numReagents, 1 do
			local reagentName, _, reagentCount = LSW_GetTradeSkillReagentInfo(skillID, i);
			local reagentLink = LSW_GetTradeSkillReagentItemLink(skillID, i);
			local reagentID = LSW_findID(reagentLink);

			LSW_queryServerInfo(reagentLink);

			local sellAtAuction;
			local buyFromVendor;
			local ahDataMissing;

			local reagentValue;

			local vendorSellsItem = false;

			if LSW_periodicTableLib and reagentID then
				vendorSellsItem = LSW_periodicTableLib:ItemInSet(reagentID,"Tradeskill.Mat.BySource.Vendor")
			end

			buyFromVendor = LSW_itemPriceVendor(reagentLink);

			if (vendorSellsItem) then		-- reagent can be purchased from vendor
				reagentValue = buyFromVendor;
			else							-- reagent cannot be purchased from vendor
				sellAtAuction, ahDataMissing = LSW_itemPrice(reagentLink, LSW_MININUM_REAGENT_AUCTIONS);

	-- calculate the cost of reagents.  if ah data exists, use it.  if no ah data exists then use the buy from vendor price

				if (ahDataMissing or sellAtAuction < 0) then
					reagentValue = buyFromVendor;
				else
					reagentValue = sellAtAuction;
				end
			end


	--LSW_ErrorMessage(reagentLink.."  "..reagentValue);


			buy = buy + reagentValue * reagentCount;
		end

		cache.costAmount = buy;  -- costAmount = how much it would cost to purchase the reagents

		if (itemID and GetItemInfo(itemID)) then  -- items return info, enchants return nil
			local min,max;
			local data_missing;
			local _, itemLink = GetItemInfo(itemID)

			min, max = LSW_GetTradeSkillNumMade(skillID); -- unfortunately, blizzard hasn't yet fixed this to return the correct number of items for specialists

	-- LSW_ErrorMessage(skillName.."  "..min.." "..max);

			stacks = (min+max)/2;

			sell, data_missing = LSW_itemPrice(itemLink, LSW_MINIUMUM_ITEM_AUCTIONS);

			if (data_missing == false) then
				cache.valueAmount[1] = sell * stacks;						-- valueAmount[1] = how much an item might auction for

			else
				if (LSW_bopCheck(itemID)) then
					cache.valueAmount[1] = -2;								-- ah price of -2 = BOP
				end
			end


			dummy, sell, data_missing = LSW_itemPriceVendor(itemLink);
			if (data_missing == false) then cache.valueAmount[2] = sell * stacks; end -- valueAmount[2] = how much an item would sell to a vendor for


			if (dePricer) then
				dummy, dummy, dummy, sell = dePricer(itemLink); -- aucadvanced
			else
				sell = nil;
			end

			if (sell) then
				cache.valueAmount[3] = sell * stacks;  -- valueAmount[3] = how much an item would sell for if de'd
			end


			if (cache.valueAmount[1] >= cache.valueAmount[2] and cache.valueAmount[1] >= cache.valueAmount[3]) then
				cache.valueAmount[0] = cache.valueAmount[1];
				cache.itemFate = LSW_itemFateList[1];
			else
				if (cache.valueAmount[2] >= cache.valueAmount[3] and cache.valueAmount[2] >= cache.valueAmount[1]) then
					cache.valueAmount[0] = cache.valueAmount[2];
					cache.itemFate = LSW_itemFateList[2];
				else
					cache.valueAmount[0] = cache.valueAmount[3];
					cache.itemFate = LSW_itemFateList[3];
				end
			end
		else

		--[[ scroll stuff.. work in progress

	--DEFAULT_CHAT_FRAME:AddMessage(GetSpellInfo(recipeID) or "nil")

	--
			local scrollName = string.lower("Scroll of "..GetSpellInfo(recipeID))
	--		local _, itemLink = GetItemInfo(scrollName)
			local itemLink

			local matching = AucAdvanced.API.QueryImage({ name = scrollName })

			if matching and matching[1] then
				itemLink = matching[1][1]
			end


	--DEFAULT_CHAT_FRAME:AddMessage((scrollName or "noName").. " "..(itemLink or "noLink"))


			sell = -1

			if itemLink then
				sell, data_missing = LSW_itemPrice(itemLink, LSW_MINIUMUM_ITEM_AUCTIONS);

				if data_missing then
					sell = -1;
				end
			end

			cache.itemFate = LSW_itemFateList[1];
			cache.valueAmount[0] = sell;
			cache.valueAmount[1] = sell;
			cache.valueAmount[2] = -1;
			cache.valueAmount[3] = -1;
			]]

			cache.itemFate = LSW_ENCHANT_ID -- an enchant has no values
			cache.valueAmount[0] = -1;
			cache.valueAmount[1] = -1;
			cache.valueAmount[2] = -1;
			cache.valueAmount[3] = -1;
		end


		LSW_skillPriceCache[recipeID].sync = LSW_globalSync;

		if (LSW_globalFate==0) then
			return LSW_skillPriceCache[recipeID].costAmount, LSW_skillPriceCache[recipeID].valueAmount[LSW_globalFate], LSW_skillPriceCache[recipeID].itemFate;
		else
			return LSW_skillPriceCache[recipeID].costAmount, LSW_skillPriceCache[recipeID].valueAmount[LSW_globalFate], LSW_itemFateList[LSW_globalFate];
		end
	end


	local function LSW_SortCompareItemValue(tradeskill, a, b)
		while a.subGroup and #a.subGroup.entries>0 do
			a = a.subGroup.entries[1]
		end

		while b.subGroup and #b.subGroup.entries>0 do
			b = b.subGroup.entries[1]
		end

		local left_r = Skillet:GetRecipe(a.recipeID)
		local right_r = Skillet:GetRecipe(b.recipeID)

		_,_,  left = GetItemInfo(left_r.itemID)
		_,_, right = GetItemInfo(right_r.itemID)

		if not left  then  left = 0 end
		if not right then right = 0 end

		local _, itemValueA = LSW_itemValuation(a.recipeID, left, a.skillIndex);
		local _, itemValueB = LSW_itemValuation(b.recipeID, right, b.skillIndex);

		if (itemValueA > itemValueB) then return true; end

		return false;
	end


	local function LSW_SortCompareReagentCost(skill,b,a)  -- lowest cost first so i swap b and a
		while a.subGroup and #a.subGroup.entries>0 do
			a = a.subGroup.entries[1]
		end

		while b.subGroup and #b.subGroup.entries>0 do
			b = b.subGroup.entries[1]
		end

		local left_r = Skillet:GetRecipe(a.recipeID)
		local right_r = Skillet:GetRecipe(b.recipeID)

		_,_,  left = GetItemInfo(left_r.itemID)
		_,_, right = GetItemInfo(right_r.itemID)

		if not left  then  left = 0 end
		if not right then right = 0 end

		local itemCostA = LSW_itemValuation(a.recipeID, left, a.skillIndex);
		local itemCostB = LSW_itemValuation(b.recipeID, right, b.skillIndex);

		if (itemCostA > itemCostB) then return true; end

		return false;
	end


	local function LSW_SortCompareProfit(skill,a,b)  -- highest profit first
		while a.subGroup and #a.subGroup.entries>0 do
			a = a.subGroup.entries[1]
		end

		while b.subGroup and #b.subGroup.entries>0 do
			b = b.subGroup.entries[1]
		end

		local left_r = Skillet:GetRecipe(a.recipeID)
		local right_r = Skillet:GetRecipe(b.recipeID)

		_,_,  left = GetItemInfo(left_r.itemID)
		_,_, right = GetItemInfo(right_r.itemID)

		if not left  then  left = 0 end
		if not right then right = 0 end

		local itemCostA, itemValueA = LSW_itemValuation(a.recipeID, left, a.skillIndex);
		local itemCostB, itemValueB = LSW_itemValuation(b.recipeID, right, b.skillIndex);

		itemProfitA = itemValueA - itemCostA;
		itemProfitB = itemValueB - itemCostB;

		if (itemProfitA > itemProfitB) then return true; end

		return false;
	end



	local function LSW_CreateDynamicButtons(id, buttonName, ParentFrame)

	--LSW_ErrorMessage("creating button "..id);

		local buttonValue = CreateFrame("Button", "LSWTradeSkillValue"..id, ParentFrame, "LSWTradeSkillValueButtonTemplate");
		buttonValue:SetPoint("TOPLEFT",buttonName,"TOPRIGHT",5,0);

		buttonValue.text = getglobal("LSWTradeSkillValue"..id.."Text")
		buttonValue.text:SetText("00 00");
		buttonValue:Hide();

		if (LSW_Mode == "Skillet") then
			buttonValue:SetWidth(40);
		else
			buttonValue:SetWidth(40);
		end


		local buttonCost = CreateFrame("Button", "LSWTradeSkillCost"..id, ParentFrame, "LSWTradeSkillCostButtonTemplate");
		buttonCost:SetPoint("TOPLEFT",buttonName,"TOPRIGHT",buttonValue:GetWidth()+15,0);

		buttonCost.text = getglobal("LSWTradeSkillCost"..id.."Text")
		buttonCost.text:SetText("00 00");

		buttonCost:SetWidth(40);
		buttonCost:Hide();


		local buttonLevel = CreateFrame("Button", "LSWTradeSkillItemLevel"..id, ParentFrame, "LSWTradeSkillItemLevelTemplate");
		buttonLevel:SetPoint("TOPLEFT",buttonName,"TOPLEFT",5,0);

		buttonLevel.text = getglobal("LSWTradeSkillItemLevel"..id.."Text")
		buttonLevel.text:SetText("00 00");

		buttonLevel:SetText("");
		buttonLevel:Hide();

		return buttonValue, buttonCost, buttonLevel;
	end




	local function LSW_SkillShow(button)
		local name = button:GetName();
		local itemLevel = "?";
		local x;
		local id;
		local recipeLink;

		local buttonLevel;
		local buttonCost;
		local buttonValue;

		if (LSW_Mode == "Skillet") then

			id = string.sub(name,20); -- SkilletScrollButton[id]

			buttonValue = getglobal("LSWTradeSkillValue"..id);
			buttonCost = getglobal("LSWTradeSkillCost"..id);
			buttonLevel = getglobal("LSWTradeSkillItemLevel"..id);

			if (not buttonValue) then
				buttonValue, buttonCost, buttonLevel = LSW_CreateDynamicButtons(id, name, SkilletFrame);
			end

			local width = SkilletSkillListParent:GetWidth()-100;

			if (SkilletSkillList:IsVisible()) then
				width = width-20;
			end

			button:SetWidth(width);
		elseif (LSW_Mode == "ATSW") then
			id = string.sub(name,10); -- ATSWSkill[id]

			buttonValue = getglobal("LSWTradeSkillValue"..id);
			buttonCost = getglobal("LSWTradeSkillCost"..id);
			buttonLevel = getglobal("LSWTradeSkillItemLevel"..id);

			button:SetWidth(LSW_skillWidth);
		else
			id = string.sub(name,16); -- TradeSkillSkill[id]

			buttonValue = getglobal("LSWTradeSkillValue"..id);
			buttonCost = getglobal("LSWTradeSkillCost"..id);
			buttonLevel = getglobal("LSWTradeSkillItemLevel"..id);

			button:SetWidth(LSW_skillWidth);
		end

		if (not buttonValue) then return; end



		local skillName;
		local skillLink;
		local skillType;
		local skillID;

		local recipeID
		local itemID

		if (LSW_Mode == "ATSW") then
			local tradeSkillID=button:GetID();
			local listpos=ATSW_GetSkillListingPos(tradeSkillID);

			if(atsw_skilllisting[listpos]) then
				skillName = atsw_skilllisting[listpos].name;
				skillLink = atsw_skilllisting[listpos].link;
				skillType = atsw_skilllisting[listpos].type;
				skillID =   atsw_skilllisting[listpos].id;
				recipeLink = atsw_skilllisting[listpos].recipelink;
			end

	--		LSW_ErrorMessage("ATSW: "..skillName.." "..skillLink.." "..skillType.." "..skillID);

		else
			skillID=button:GetID();

			if (LSW_Mode == "Skillet" and (button.skill and button.skill.subGroup)) then
				skillType = "header"
				skillName = ""
				skillLink = ""
			else
				skillName, skillType = LSW_GetTradeSkillInfo(skillID);
				skillLink = LSW_GetTradeSkillItemLink(skillID);
				recipeLink = LSW_GetTradeSkillRecipeLink(skillID);

	--			DEFAULT_CHAT_FRAME:AddMessage((recipeLink or "nil").." makes "..(skillLink or "nil"))
			end
		end


		recipeID = LSW_findID(recipeLink)
		itemID = LSW_findID(skillLink)


		buttonCost:SetID(skillID);
		buttonValue:SetID(skillID);
		buttonLevel:SetID(skillID);



		if (recipeID and skillType ~= "header") then
	--DEFAULT_CHAT_FRAME:AddMessage(id.."="..recipeID.." "..button.skill.name.." "..(itemID or skillLink or "nil"))
	--		local recipeName = LSW_nameFromLink(recipeLink);

	--		local costAmount, valueAmount, itemFate = LSW_itemValuation(skillName, skillLink, skillID);
			local costAmount, valueAmount, itemFate = LSW_itemValuation(recipeID, itemID, skillID);

			local itemFateString = string.format("|c%s%s|r", LSW_itemFateColor[itemFate], itemFate);
			local hilight = (costAmount < valueAmount);
			local valueText;


			if (LSW_valueAsPercent) then
				if (costAmount > 0 and valueAmount > 0) then
					local per = valueAmount / costAmount;



					if per < .1 then
						per = math.floor(per*1000)/10;
						valueText = string.format("%2.1f%%",per);
					elseif per > 10 then
						per = math.floor(per*10)/10;
						valueText = string.format("%2.1fx",per);
					else
						per = math.floor(per*100);
						valueText = per.."%"
					end

					if (hilight) then
						valueText = "|cffd0d0d0"..valueText..itemFateString;
					else
						valueText = "|cffd02020"..valueText..itemFateString;
					end

				elseif (valueAmount > 0) then
					valueText = "inf"..itemFateString;
				else
					if (valueAmount == -2) then
						valueText = LSW_BOP_STRING;
					else
						valueText = "--"..itemFateString;
					end
				end
			else
				if (valueAmount == -2) then
					valueText = LSW_BOP_STRING;
				else
					valueText = LSW_formatMoney(valueAmount,hilight)..itemFateString;
				end
			end


			buttonValue.text:SetText(valueText);
			buttonCost.text:SetText(LSW_formatMoney(costAmount,false).."  ");


			if (recipeID) then
				buttonValue:Show();

				if itemID then
					LSW_itemMade[recipeID] = itemID;

					if not LSW_itemSource[itemID] then
						LSW_itemSource[itemID] = {}
					end

					LSW_itemSource[itemID][recipeID] = LSW_GetTradeSkillNumMade(skillID)


					local _, _, quality, _, itemLevel = GetItemInfo(itemID);

					if (itemLevel) then
						local r,g,b,hex = GetItemQualityColor(quality);

						if (itemLevel == 0) then
							itemLevel = "1"
						end

						buttonLevel.text:SetText(hex..itemLevel);

						if (LSW_Mode ~= "Skillet") then
							buttonLevel:Show();
						else
							buttonLevel:Hide();
						end
					end


				else
					buttonLevel.text:SetText("");
					buttonLevel:Hide();

	--				buttonValue.text:SetText(" ");
	--				buttonValue:Show();
				end
			else
				buttonValue:Hide();
				buttonLevel:Hide();
			end

			buttonCost:Show();
		else
			buttonValue:Hide();
			buttonCost:Hide();
			buttonLevel:Hide();
		end
	end




	local function LSW_SkillHide(button)
		local name = button:GetName();
		local idloc = string.find(name,"%d");
		local id = string.sub(name,idloc);

		local buttonLevel;
		local buttonCost;
		local buttonValue;

		local namebase = string.sub(name,1,idloc-1);

		if (namebase == "TradeskillInfoSkill") then
			id = id + 1000;
		end

		buttonValue = getglobal("LSWTradeSkillValue"..id);
		buttonCost = getglobal("LSWTradeSkillCost"..id);
		buttonLevel = getglobal("LSWTradeSkillItemLevel"..id);

		if (buttonCost) then buttonCost:Hide(); end
		if (buttonValue) then buttonValue:Hide(); end
		if (buttonLevel) then buttonLevel:Hide(); end

	--	LSW_ChatMessage("Hide "..name);
	end


	function LSW_ItemLevelButton_OnEnter()
		LSW_Tooltip:SetOwner(this, "ANCHOR_NONE");
		LSW_Tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);
		LSW_Tooltip:SetText("Required level to use crafted item.");
		LSW_Tooltip:Show();
	end

	function LSW_ItemLevelButton_OnLeave()
		LSW_Tooltip:Hide();
	end



	function LSW_CostButton_OnEnter()
	-- LSW_ErrorMessage("skill cost enter");
		LSW_Tooltip:SetOwner(this, "ANCHOR_NONE");
		LSW_Tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);

		if (LSW_priceSanity) then
			local skillName, itemID, skillType, skillID, recipeID = LSW_GetSkillByID(this:GetID());

			if (skillType ~= "header") then
				if (itemID) then
					local _, _, quality = GetItemInfo(itemID);
					local r, g, b = 1,1,1;

					if (quality) then
						r,g,b = GetItemQualityColor(quality);
					end

					LSW_Tooltip:AddLine(skillName, r,g,b, 1.0);
				else
					LSW_Tooltip:AddLine(GetSpellLink(recipeID))
				end

				local vendorSellsItem = false;

				local costAmount, valueAmount, itemFate = LSW_itemValuation(recipeID, itemID, skillID);
				local total = 0;

				local numReagents;

				numReagents = LSW_GetTradeSkillNumReagents(skillID);

				for i=1, numReagents, 1 do
					local reagentName, dummy, reagentCount = LSW_GetTradeSkillReagentInfo(skillID, i);

					if not reagentName then
						break
					end

					local reagentLink = LSW_GetTradeSkillReagentItemLink(skillID, i);
					LSW_queryServerInfo(reagentLink)

					local reagentID = LSW_findID(reagentLink);

					local sellAtAuction;
					local buyFromVendor;
					local ahDataMissing;

					local reagentValue;
					local reagentSource="a";

					local reagentSubTotal;


					_, _, quality = GetItemInfo(reagentLink);
					if (quality) then
						r, g, b = GetItemQualityColor(quality);
					else
						r = 1
						g = 1
						b = 1
					end

					sellAtAuction, ahDataMissing = LSW_itemPrice(reagentLink, LSW_MININUM_REAGENT_AUCTIONS);

					buyFromVendor = LSW_itemPriceVendor(reagentLink);

					if LSW_periodicTableLib then
					   vendorSellsItem = LSW_periodicTableLib:ItemInSet(reagentID,"Tradeskill.Mat.BySource.Vendor")
					end

	-- calculate the cost of reagents.  if ah data exists, use it.  if no ah data exists then use the buy from vendor price
					if (vendorSellsItem) then
						reagentValue = buyFromVendor;
						reagentSource = "v"
					else
						if (ahDataMissing or sellAtAuction < 0) then
							if (buyFromVendor > 0) then
								reagentValue = buyFromVendor;
								reagentSource = "v";
							else
								if (LSW_bopCheck(reagentID)) then
									reagentValue = "";
									reagentSource = LSW_BOP_STRING;
								else
									reagentValue = ""
									reagentSource = "?";
								end
							end
						else
							reagentValue = sellAtAuction;
						end
					end

					if (type(reagentValue) == "number") then
						reagentSubTotal = reagentValue * reagentCount;
						LSW_Tooltip:AddDoubleLine(reagentName.." x "..reagentCount, LSW_formatMoney(reagentSubTotal, true)..reagentSource, r, g, b);
					else
						reagentSubTotal = 0;
						LSW_Tooltip:AddDoubleLine(reagentName.." x "..reagentCount, reagentSource, r, g, b);
					end


					total = total + reagentSubTotal;
				end

				LSW_Tooltip:AddDoubleLine("Total estimated cost: ", LSW_formatMoney(total,true).."  ");
			end
		else
			LSW_Tooltip:SetText("Estimated cost to use skill.");
		end

		LSW_Tooltip:Show();
	end

	function LSW_CostButton_OnLeave()
		LSW_Tooltip:Hide();
	end

	function LSW_CostButton_OnClick(frame, button)
		if (frame:GetText() == " ") then return end

		local needsUpdate = false;

		if (button=="RightButton") then
			if aucEngineMenu then
				for i=1,#aucEngineMenu do
					if aucEngineMenu[i].text == aucAlgorithm then
						aucEngineMenu[i].checked = true
					else
						aucEngineMenu[i].checked = nil
					end
				end
				EasyMenu(aucEngineMenu, LSWMenuFrame, frame, 0,0, nil, 5)
			end
		end

		if (needsUpdate) then
			LSW_ValueButton_OnEnter()

			LSW_UpdateWindow()
		end
	end



	function LSW_ValueButton_OnClick(frame, button)
		if (frame:GetText() == " ") then return end

		local needsUpdate = false;

		if(button=="LeftButton") then
			LSW_globalFate = LSW_globalFate + 1;

			if (LSW_globalFate > LSW_globalFateMax) then
				LSW_globalFate = 0;
			end

			needsUpdate = true;
		elseif (button=="RightButton") then
--			LSW_valueAsPercent = not LSW_valueAsPercent;

--			needsUpdate = true;

--			EasyMenu(menuList, menuFrame, anchor, x, y, displayMode, autoHideDelay)

			if LSW_valueAsPercent == true then
				ValueMenu[1].checked = true
			else
				ValueMenu[1].checked = nil
			end

			if aucEngineMenu then
				for i=1,#aucEngineMenu do
					if aucEngineMenu[i].text == aucAlgorithm then
						aucEngineMenu[i].checked = true
					else
						aucEngineMenu[i].checked = nil
					end
				end
			end

			EasyMenu(ValueMenu, LSWMenuFrame, frame, 0,0,nil, 5)
		end

		if (needsUpdate) then
			LSW_ValueButton_OnEnter()

			LSW_UpdateWindow()
		end
	end

	function LSW_ValueButton_OnEnter()
		if (this:GetText() == " ") then return end

		LSW_Tooltip:SetOwner(this, "ANCHOR_NONE");
		LSW_Tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);

		local skillName, itemID, skillType, skillID, recipeID = LSW_GetSkillByID(this:GetID());

		if (skillName and skillType ~= "header") then
			local itemFate = LSW_skillPriceCache[recipeID].itemFate;

			if (itemFate ~= LSW_ENCHANT_ID) then
				local min,max = GetTradeSkillNumMade(skillID);
				local numMade = (min + max)/2;


				local madeText = skillName;

				if itemID then
					local _, _, quality = GetItemInfo(itemID);
					local r, g, b = 1,1,1;

					if (quality) then
						r,g,b = GetItemQualityColor(quality);
					end

					if (numMade > 1) then
						madeText = skillName.." (x"..numMade..")";
					end
				else
					madeTest = "Scroll of "..skillName
				end

				local auctionValue = LSW_formatMoney(LSW_skillPriceCache[recipeID].valueAmount[1],(itemFate=="a"));
				local vendorValue = LSW_formatMoney(LSW_skillPriceCache[recipeID].valueAmount[2],(itemFate=="v"));
				local disenchantValue = LSW_formatMoney(LSW_skillPriceCache[recipeID].valueAmount[3],(itemFate=="d"));

				if (LSW_skillPriceCache[recipeID].valueAmount[1] == -2) then
					auctionValue = LSW_BOP_STRING;
				end


				LSW_Tooltip:SetText(madeText,r,g,b);
	--			LSW_Tooltip:AddDoubleLine("Item Fate:", "|c"..LSW_itemFateColor[itemFate]..LSW_fateString[itemFate],1,1,1);

				LSW_Tooltip:AddDoubleLine("|cff909040Auction: ",auctionValue);
				LSW_Tooltip:AddDoubleLine("|cff206080Vendor: ",vendorValue);

				if (Enchantrix) then
					LSW_Tooltip:AddDoubleLine("|cff008000Disenchant: ",disenchantValue);
				end

				local cycleString;

				if (LSW_globalFate == 0) then
					cycleString = "[Best Value Shown]"
				else
					cycleString = "["..LSW_fateString[LSW_itemFateList[LSW_globalFate]].." Value Shown]";
				end

				LSW_Tooltip:AddLine(cycleString,1,1,1);

				LSW_Tooltip:Show();
			end
		end
	end

	function LSW_ValueButton_OnLeave()
		LSW_Tooltip:Hide();
	end


	local function LSW_ShowWindowATSW()
		LSW_globalSync = LSW_globalSync + 1;
		LSW_Mode = "ATSW";

		ATSW_ShowWindow_ORIGINAL();

		local scrollFrame = ATSWListScrollFrame;

		if (ATSWListScrollFrame:IsVisible()) then
			LSW_skillWidth = LSW_skillWidthNarrow;
		else
			LSW_skillWidth = LSW_skillWidthWide;
		end

		local ATSW_title = ATSWFrameTitleText:GetText();
		ATSWFrameTitleText:SetText(ATSW_title.." (w/ "..LSW_VERSION..")");
		ATSWFrame_Update();
	end



	local function LSW_SkilletBeforeRecipeButtonShow(button, tradeskill, skill_index, list_offset)
		LSW_SkillShow(button);
		return button;
	end

	local function LSW_SkilletBeforeRecipeButtonHide(button, tradeskill, skill_index, list_offset)
		LSW_SkillHide(button);
		return button;
	end


	local function LSW_ShowWindowSkillet(obj)
		LSW_globalSync = LSW_globalSync + 1;
		LSW_Mode = "Skillet";

		SkilletFrame_Show_ORIGINAL(obj);
	end


	local function LSW_ShowWindowStandard()
		LSW_globalSync = LSW_globalSync + 1;
		LSW_Mode = "TradeSkill";

		TradeSkillFrame_Show_ORIGINAL();

		if (TradeSkillListScrollFrame:IsVisible()) then
			LSW_skillWidth = LSW_skillWidthNarrow;
		else
			LSW_skillWidth = LSW_skillWidthWide;
		end

		TradeSkillFrame_Update();
	end


	local function LSW_UpdateWindowSkillet(obj)
		LSW_Mode = "Skillet";

		SkilletFrame_Update_ORIGINAL(obj);

		local title = getglobal("SkilletTitleText");

		if (title and Skillet.currentTrade) then
			title:SetText("Skillet Trade Skills"..": "..((GetSpellInfo(Skillet.currentTrade)) or Skillet.currentTrade).." ("..LSW_VERSION..")")
		end
	end



	local function LSW_UpdateWindowStandard()
		LSW_Mode = "TradeSkill";

		for i=1, LSW_TRADESKILL_INDEX_MAX, 1 do
			local tradeSkillButton = getglobal("TradeSkillSkill"..i);
			tradeSkillButton:Hide();
			getglobal("LSWTradeSkillValue"..i):Hide();
			getglobal("LSWTradeSkillCost"..i):Hide();
			getglobal("LSWTradeSkillItemLevel"..i):Hide();
		end

		TradeSkillFrame_Update_ORIGINAL()

		for i=1, LSW_TRADESKILL_INDEX_MAX, 1 do
			local tradeSkillButton = getglobal("TradeSkillSkill"..i);
			local text = tradeSkillButton:GetText()

			if text then
				text = string.gsub(text, "Enchant ","+")

				tradeSkillButton:SetText(text)
			end
		end

		local name = GetTradeSkillLine()
		TradeSkillFrameTitleText:SetText(name.." ("..LSW_VERSION..")");
	end



	-- click on the value and toggle the BEST/AUCTION/VENDOR/DE price consideration
	function LSW_UpdateWindow()
		if (LSW_Mode == "Skillet") then
			if Skillet.SortAndFilterRecipes then
				Skillet:SortAndFilterRecipes();
			end
			LSW_UpdateWindowSkillet(Skillet);
		elseif (LSW_Mode == "ATSW") then
			ATSWFrame_Update();
		else
			LSW_UpdateWindowStandard();
		end
	end




	local function LSW_ButtonInitATSW(i)
		local atswButton = getglobal("ATSWSkill"..i);
		atswButton:SetScript("OnShow", LSW_SkillShow);
		atswButton:SetScript("OnHide", LSW_SkillHide);
	--	atswButton:SetNormalFontObject("GameFontNormalSmall");
		atswButton:SetHighlightFontObject("GameFontHighlightSmall");
		atswButton:SetDisabledFontObject("GameFontDisableSmall");

		LSW_CreateDynamicButtons(i, "ATSWSkill"..i, ATSWFrame);
	end


	local function LSW_ButtonInitStandard(i)
		local tradeSkillButton = getglobal("TradeSkillSkill"..i);

		if tradeSkillButton then
			tradeSkillButton:SetScript("OnShow", LSW_SkillShow);
			tradeSkillButton:SetScript("OnHide", LSW_SkillHide);
		--	tradeSkillButton:SetNormalFontObject("GameFontNormalSmall");
			tradeSkillButton:SetHighlightFontObject("GameFontHighlightSmall");
			tradeSkillButton:SetDisabledFontObject("GameFontDisableSmall");
			tradeSkillButton:SetWidth(LSW_skillWidth);

			LSW_CreateDynamicButtons(i, "TradeSkillSkill"..i, TradeSkillFrame);
		end

		return tradeSkillButton
	end


	function LSW_OnLoad()
		LSW_initialized = LSW_InitializeFrames()

	--	LSW_InitializePricing();
	end


	function LSW_OnEvent(event)
--[[
		if (LSW_initialized == false) then
			if (event == "TRADE_SKILL_SHOW") then
				LSW_initialized = LSW_Initialize();
			end
		end
]]
	end





-- old skillet sort routines


	local function LSW_SortCompareItemValue_OLD(skill,a,b)  -- highest value first
		local skillLinkA, skillNameA;
		local skillLinkB, skillNameB;
		local itemValueA=0;
		local itemValueB=0;
		local x;

		skillNameA = LSW_GetTradeSkillInfo(a);
		skillLinkA = LSW_GetTradeSkillItemLink(a);

		skillNameB = LSW_GetTradeSkillInfo(b);
		skillLinkB = LSW_GetTradeSkillItemLink(b);

		x, itemValueA = LSW_itemValuation(skillNameA, skillLinkA, a);
		x, itemValueB = LSW_itemValuation(skillNameB, skillLinkB, b);

		if (itemValueA > itemValueB) then return true; end

		return false;
	end


	local function LSW_SortCompareReagentCost_OLD(skill,b,a)  -- lowest cost first so i swap b and a
		local skillLinkA, skillNameA;
		local skillLinkB, skillNameB;
		local itemCostA=0;
		local itemCostB=0;
		local x;

		skillNameA = LSW_GetTradeSkillInfo(a);
		skillLinkA = LSW_GetTradeSkillItemLink(a);

		skillNameB = LSW_GetTradeSkillInfo(b);
		skillLinkB = LSW_GetTradeSkillItemLink(b);

		itemCostA = LSW_itemValuation(skillNameA, skillLinkA, a);
		itemCostB = LSW_itemValuation(skillNameB, skillLinkB, b);

		if (itemCostA > itemCostB) then return true; end

		return false;
	end


	local function LSW_SortCompareProfit_OLD(skill,a,b)  -- highest profit first
		local skillLinkA, skillNameA;
		local skillLinkB, skillNameB;
		local itemCostA, itemValueA, itemProfitA;
		local itemCostB, itemValueB, itemProfitB;

	--LSW_ErrorMessage("compare "..a.." to "..b);

		skillNameA = LSW_GetTradeSkillInfo(a);
		skillLinkA = LSW_GetTradeSkillItemLink(a);

		skillNameB = LSW_GetTradeSkillInfo(b);
		skillLinkB = LSW_GetTradeSkillItemLink(b);

		itemCostA, itemValueA = LSW_itemValuation(skillNameA, skillLinkA, a);
		itemCostB, itemValueB = LSW_itemValuation(skillNameB, skillLinkB, b);

		itemProfitA = itemValueA - itemCostA;
		itemProfitB = itemValueB - itemCostB;

		if (itemProfitA > itemProfitB) then return true; end

		return false;
	end




	function LSW_InitializeFrames()
		LSW_ChatMessage(LSW_VERSION_LONG);


		if (Skillet and Skillet.version) then
			LSW_Mode = "Skillet"

			LSW_ChatMessage("LilSparky's Workshop plugging into Skillet (v"..Skillet.version..")");

			if (Skillet.ShowTradeSkillWindow) then
				SkilletFrame_Show_ORIGINAL = Skillet.ShowTradeSkillWindow;
				Skillet.ShowTradeSkillWindow = LSW_ShowWindowSkillet;

				SkilletFrame_Update_ORIGINAL = Skillet.UpdateTradeSkillWindow;
				Skillet.UpdateTradeSkillWindow = LSW_UpdateWindowSkillet;


				Skillet:AddPreButtonShowCallback(LSW_SkilletBeforeRecipeButtonShow)
				Skillet:AddPreButtonHideCallback(LSW_SkilletBeforeRecipeButtonHide)
			else
				LSW_ChatMessage("ERROR: unable to hook into Skillet Show/Update functions.");

				return false;
			end

			if string.find(Skillet.version, "LS") then
				Skillet:AddRecipeSorter("LSW: Item Value", LSW_SortCompareItemValue)
				Skillet:AddRecipeSorter("LSW: Reagent Cost", LSW_SortCompareReagentCost)
				Skillet:AddRecipeSorter("LSW: Profit", LSW_SortCompareProfit)
			else
				Skillet:AddRecipeSorter("LSW: Item Value", LSW_SortCompareItemValue_OLD)
				Skillet:AddRecipeSorter("LSW: Reagent Cost", LSW_SortCompareReagentCost_OLD)
				Skillet:AddRecipeSorter("LSW: Profit", LSW_SortCompareProfit_OLD)
			end

			LSW_TRADESKILL_INDEX_MAX = 1;
		elseif (ATSW_ShowWindow) then
			LSW_Mode = "ATSW"

			ATSW_ShowWindow_ORIGINAL = ATSW_ShowWindow;
			ATSW_ShowWindow = LSW_ShowWindowATSW;

			LSW_ChatMessage("LilSparky's Workshop plugging into AdvancedTradeSkillWindow.");


			ATSWTypeColor["optimal"]	= { r = 1.00, g = 0.50, b = 0.25,	font = LSWFontNormalLeftOrange };
			ATSWTypeColor["medium"]	= { r = 1.00, g = 1.00, b = 0.00,	font = LSWFontNormalLeftYellow };
			ATSWTypeColor["easy"]		= { r = 0.25, g = 0.75, b = 0.25,	font = LSWFontNormalLeftLightGreen };
			ATSWTypeColor["trivial"]	= { r = 0.50, g = 0.50, b = 0.50,	font = LSWFontNormalLeftGrey };
			ATSWTypeColor["header"]	= { r = 1.00, g = 0.82, b = 0,		font = GameFontNormalSmallLeft };


			LSW_TRADESKILL_INDEX_MAX = ATSW_TRADE_SKILLS_DISPLAYED;

			LSW_skillWidthNarrow = 213;
			LSW_skillWidthWide = 233;

			LSW_skillWidth = LSW_skillWidthNarrow;

			for i=1, LSW_TRADESKILL_INDEX_MAX, 1 do
				LSW_ButtonInitATSW(i);
			end
		else
			LSW_ChatMessage("LilSparky's Workshop plugging into standard Tradeskill frame.");


--			TradeSkillFrame_LoadUI()



			TradeSkillTypeColor["optimal"]	= { r = 1.00, g = 0.50, b = 0.25,	font = LSWFontNormalLeftOrange };
			TradeSkillTypeColor["medium"]	= { r = 1.00, g = 1.00, b = 0.00,	font = LSWFontNormalLeftYellow };
			TradeSkillTypeColor["easy"]		= { r = 0.25, g = 0.75, b = 0.25,	font = LSWFontNormalLeftLightGreen };
			TradeSkillTypeColor["trivial"]	= { r = 0.50, g = 0.50, b = 0.50,	font = LSWFontNormalLeftGrey };
			TradeSkillTypeColor["header"]	= { r = 1.00, g = 0.82, b = 0,		font = GameFontNormalSmallLeft };


			TradeSkillFrame_Show_ORIGINAL = TradeSkillFrame_Show;
			TradeSkillFrame_Show = LSW_ShowWindowStandard;

			TradeSkillFrame_Update_ORIGINAL = TradeSkillFrame_Update;
			TradeSkillFrame_Update = LSW_UpdateWindowStandard;




			LSW_skillWidthNarrow = 208;
			LSW_skillWidthWide = 228;

			LSW_skillWidth = LSW_skillWidthNarrow;

			LSW_TRADESKILL_INDEX_MAX = 1

			for i=1,100 do
				if not LSW_ButtonInitStandard(i) then
					break
				else
					LSW_TRADESKILL_INDEX_MAX = i
				end
			end
		end

		LSW_Tooltip = CreateFrame("GameTooltip", "LSW_Tooltip", getglobal("ANCHOR_NONE"), "GameTooltipTemplate");
		LSW_Tooltip:SetScale(0.8);
		return true;
	end
end

